# https://help.aliyun.com/zh/dashscope/developer-reference/quick-start-13?spm=a2c4g.11186623.0.0.26772e5cs8Vl59

from typing import Any
from src import TTSEngine as TTSEngine

import dashscope
from dashscope.audio.tts import SpeechSynthesizer

from logging import getLogger
logger = getLogger(__name__)

# import requests
# r = requests.get(
# 'https://dashscope.oss-cn-beijing.aliyuncs.com/samples/audio/paraformer/hello_world_female2.wav'
# )
# with open('asr_example.wav', 'wb') as f:
#     f.write(r.content)
    
class TTSSambert(TTSEngine):

    def __init__(self, api_key : str,
                 _model : str = "sambert-zhichu-v1",
                 _is_stream : bool = False,
                 *args, **kwargs) -> None:
        super().__init__(kwargs.get("is_stream", _is_stream))
        dashscope.api_key = api_key
        self.model = kwargs.get("model", _model)
    def process_output(self, data):
        return super().process_output(data)

    def execute(self, data: Any) -> Any:
        result = SpeechSynthesizer.call(model=self.model,
                                text=data,
                                sample_rate=48000)
        if result.get_audio_data() is not None:
            return result.get_audio_data()
        else:
            raise RuntimeError('Error: ' + result.message)